#include <malloc.h>
#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <stdio.h>
#include <string.h>
#include <psprtc.h>
#include <math.h>
#include "callbacks.c"
#include "printstuff.c"

PSP_MODULE_INFO("BombBrusher", 0, 1, 1);


SceCtrlData		pad;
char			myMessage[999];
unsigned long	nColor1 = 0xffffffff;
unsigned long	nColor1d = 0x808080ff;
unsigned long	mColor1 = 0xff0000ff;
unsigned long	mColor1d = 0x800000ff;
unsigned long	bColor1 = 0x0000ffff;
unsigned long	bColor1d = 0x000080ff;
unsigned long	gColor1 = 0x00ff00ff;
unsigned long	gColor1d = 0x008000ff;

int 			exitYet, i, minesTotal, minesMarked, boardWidth, x, y, mineClicked, finishedGame;
int			difficulty = 1;
int			mines[23][23];
u32			oldButtons = 0;

int			DEBUG;



void clearStuff( int forInGame )
{
	if( forInGame == TRUE ) {
		for( i=0; i<33; i++ ) {
			printHex(0xffffff, 0, i, "                        ");
			printHex(0xffffff, 26, i, "                                        ");
		}
	} else {
		for( i=0; i<33; i++ ) {
			printHex(0xffffff, 0, i, "                                                                  ");
		}
	}
	
}

void drawBorder( int forInGame )
{
	for( i=0; i<68; i++ ) {
		printHex(bColor1d, i, 0, "");
	}
	if( forInGame == TRUE ) {
		for( i=1; i<32; i++ ) {
			printHex(bColor1d, 0, i, "");
			printHex(bColor1d, 25, i, "");
			printHex(bColor1d, 67, i, "");
		}
	} else {
		for( i=1; i<32; i++ ) {
			printHex(bColor1d, 0, i, "");
			printHex(bColor1d, 67, i, "");
		}
	}
	for( i=0; i<68; i++ ) {
		printHex(bColor1d, i, 32, "");
	}
	
}


void printStats()
{
	sprintf(myMessage, "Mines remaining: %d   ", minesTotal - minesMarked);
	printHex(nColor1, 26, 3, myMessage);
}

void drawBoard( int cX, int cY)
{
	for(x=1; x<boardWidth+1; x++) {
		for( y=1; y<boardWidth+1; y++ ) {
			if( mines[x][y]==13 ) {
				printHex(nColor1d, x+1, y+1, "");
			} else if( mines[x][y]==0 ) {
				printHex(gColor1d, x+1, y+1, "0");
			} else if( mines[x][y]==1 ) {
				printHex(gColor1d, x+1, y+1, "1");
			} else if( mines[x][y]==2 ) {
				printHex(gColor1d, x+1, y+1, "2");
			} else if( mines[x][y]==3 ) {
				printHex(gColor1d, x+1, y+1, "3");
			} else if( mines[x][y]==4 ) {
				printHex(gColor1d, x+1, y+1, "4");
			} else if( mines[x][y]==5 ) {
				printHex(gColor1d, x+1, y+1, "5");
			} else if( mines[x][y]==6 ) {
				printHex(gColor1d, x+1, y+1, "6");
			} else if( mines[x][y]==7 ) {
				printHex(gColor1d, x+1, y+1, "7");
			} else if( mines[x][y]==8 ) {
				printHex(gColor1d, x+1, y+1, "8");
			} else if( mines[x][y]==9 ) {
				printHex(mColor1d, x+1, y+1, "");
			} else if( mines[x][y]==10 ) {
				printHex(mColor1d, x+1, y+1, "");
			} else if( mines[x][y]==11 ) {
				printHex(nColor1d, x+1, y+1, "");
			} else if( mines[x][y]==12 ) {
				printHex(nColor1d, x+1, y+1, "");
			}
		}
	}
	if( mines[cX][cY]==13 ) {
		printHex(nColor1, cX+1, cY+1, "");
	} else if( mines[cX][cY]==0 ) {
		printHex(gColor1, cX+1, cY+1, "0");
	} else if( mines[cX][cY]==1 ) {
		printHex(gColor1, cX+1, cY+1, "1");
	} else if( mines[cX][cY]==2 ) {
		printHex(gColor1, cX+1, cY+1, "2");
	} else if( mines[cX][cY]==3 ) {
		printHex(gColor1, cX+1, cY+1, "3");
	} else if( mines[cX][cY]==4 ) {
		printHex(gColor1, cX+1, cY+1, "4");
	} else if( mines[cX][cY]==5 ) {
		printHex(gColor1, cX+1, cY+1, "5");
	} else if( mines[cX][cY]==6 ) {
		printHex(gColor1, cX+1, cY+1, "6");
	} else if( mines[cX][cY]==7 ) {
		printHex(gColor1, cX+1, cY+1, "7");
	} else if( mines[cX][cY]==8 ) {
		printHex(gColor1, cX+1, cY+1, "8");
	} else if( mines[cX][cY]==9 ) {
		printHex(mColor1, cX+1, cY+1, "");
	} else if( mines[cX][cY]==10 ) {
		printHex(mColor1, cX+1, cY+1, "");
	} else if( mines[cX][cY]==11 ) {
		printHex(nColor1, cX+1, cY+1, "");
	}

}

int minesNextToMe( int cX, int cY )
{
	int	minesHere;
	minesHere=0;
	if(( mines[cX-1][cY-1] == 10 ) || ( mines[cX-1][cY-1] == 11 )) {
		minesHere++;
	}
	if(( mines[cX][cY-1] == 10 ) || ( mines[cX][cY-1] == 11 )) {
		minesHere++;
	}
	if(( mines[cX+1][cY-1] == 10 ) || ( mines[cX+1][cY-1] == 11 )) {
		minesHere++;
	}
	if(( mines[cX-1][cY+1] == 10 ) || ( mines[cX-1][cY+1] == 11 )) {
		minesHere++;
	}
	if(( mines[cX][cY+1] == 10 ) || ( mines[cX][cY+1] == 11 )) {
		minesHere++;
	}
	if(( mines[cX+1][cY+1] == 10 ) || ( mines[cX+1][cY+1] == 11 )) {
		minesHere++;
	}
	if(( mines[cX-1][cY] == 10 ) || ( mines[cX-1][cY] == 11 )) {
		minesHere++;
	}
	if(( mines[cX+1][cY] == 10 ) || ( mines[cX+1][cY] == 11 )) {
		minesHere++;
	}
	return minesHere;
}

void showEverything( int cX2, int cY2 )
{
	for( x=1; x<boardWidth+1; x++ ) {
		for( y=1; y<boardWidth+1; y++ ) {
			if( (mines[x][y] == 13) || (mines[x][y] == 9) ) {
				mines[x][y] = minesNextToMe(x, y);
			}
		}
	}
	drawBoard(cX2, cX2);
	for( x=1; x<boardWidth+1; x++ ) {
		for( y=1; y<boardWidth+1; y++ ) {
			if(( mines[x][y] == 10 ) || (mines[x][y] == 11 )) {
				printHex(mColor1, x+1, y+1, "");
			}
		}
	}
}

void setupGame( void )
{
	drawBorder(TRUE);
	int	cursorX, cursorY, buttonPressed, cellsClicked, gameEnded;
	boardWidth = 0;
	minesMarked = 0;
	mineClicked = FALSE;
	cursorX = 1;
	cursorY = 1;
	cellsClicked=0;
	gameEnded=FALSE;


	if( difficulty==1 ) {
		boardWidth = 9;
		minesTotal = 10;
	} else if( difficulty==2 ) {
		boardWidth = 16;
		minesTotal = 40;
	} else if( difficulty==3 ) {
		boardWidth = 20;
		minesTotal = 80;
	} else {
		boardWidth = 22;
		minesTotal = 121;
	}

	for( x=0; x<24; x++ ) {
		for( y=0; y<24; y++ ) {
			mines[x][y] = 13;
		}
	}

	srand (time_seed ());
	for( i=0; i<minesTotal; i++ ) {
		x = ( rand() % (boardWidth) ) + 1;
		y = ( rand() % (boardWidth) ) + 1;
		if( mines[x][y] == 11 ) {
			i--;
		} else {
			mines[x][y] = 11;
		}
	}

	oldButtons = pad.Buttons;

	printHex(nColor1, 26, 30, "CROSS:    Open the selected cell.");
	printHex(nColor1, 26, 31, "SQUARE:   Mark a cell as a mine.");

	while( !gameEnded ) {
		printStats();
		drawBoard(cursorX, cursorY);
		buttonPressed=FALSE;
		while( ! buttonPressed ) {
			sceCtrlReadBufferPositive(&pad, 1);
			if( pad.Buttons != oldButtons ) {
				buttonPressed = TRUE;
			}
		}
		if( pad.Buttons != oldButtons ) {
			if( pad.Buttons & PSP_CTRL_UP ) {
				if( cursorY != 1 ) {
					cursorY--;
				}
			}
			if( pad.Buttons & PSP_CTRL_DOWN ) {
				if( cursorY != boardWidth ) {
					cursorY++;
				}
			}
			if( pad.Buttons & PSP_CTRL_LEFT ) {
				if( cursorX != 1 ) {
					cursorX--;
				}
			}
			if( pad.Buttons & PSP_CTRL_RIGHT ) {
				if( cursorX != boardWidth ) {
					cursorX++;
				}
			}
			if( pad.Buttons & PSP_CTRL_SQUARE ) {
				if( mines[cursorX][cursorY] == 13) {
					minesMarked++;
					mines[cursorX][cursorY] = 9;
				} else if( mines[cursorX][cursorY] == 11) {
					minesMarked++;
					mines[cursorX][cursorY] = 10;
				} else if( mines[cursorX][cursorY] == 9) {
					minesMarked--;
					mines[cursorX][cursorY] = 13;
				} else if( mines[cursorX][cursorY] == 10) {
					minesMarked--;
					mines[cursorX][cursorY] = 11;
				}
			}
			if( pad.Buttons & PSP_CTRL_CROSS ) {
				if( mines[cursorX][cursorY] == 11 ) {
					printHex(nColor1, cursorX+1, cursorY+1, "");
					mineClicked=TRUE;
					gameEnded=TRUE;
				} else if( mines[cursorX][cursorY] == 13 ) {
					mines[cursorX][cursorY] = minesNextToMe(cursorX, cursorY);
					cellsClicked++;
					if( cellsClicked == ((boardWidth*boardWidth)-minesTotal)) {
						drawBoard(cursorX, cursorY);
						gameEnded=TRUE;
					}
				}
			}
		}
		oldButtons = pad.Buttons;
	}
	for( i=1; i<30; i++ ) {
		printHex(0xffffff, 26, i, "                                        ");
	}
	printHex(nColor1, 26, 30, "START:    Start again.");
	printHex(nColor1, 26, 31, "TRIANGLE: Back to the main menu.");
	if( mineClicked==TRUE ) {
		mineClicked = FALSE;
		printHexC(nColor1, 26, 66, 5, "You loose.");
		showEverything(cursorX, cursorY);
	} else {
		printHexC(nColor1, 26, 66, 5, "You win! Well done.");
	}
	while( !mineClicked ) {
		sceCtrlReadBufferPositive(&pad, 1);
		if( pad.Buttons != 0 ) {
			if( pad.Buttons & PSP_CTRL_TRIANGLE ) {
				mineClicked = TRUE;
				finishedGame = TRUE;
			} else if( pad.Buttons & PSP_CTRL_START ) {
				mineClicked = TRUE;
			}
		}
	}
}




int main( void )
{
	int	finished = FALSE;
	int	selection, selectionMade;

	pspDebugScreenInit();
	SetupCallbacks();

	oldButtons = pad.Buttons;

	while( !finished ) {
		selectionMade = FALSE;
		selection = 1;
		drawBorder(FALSE);
		printHexC(nColor1, 1, 66, 3, "Welcome to Bomb Brusher!");
		while( !selectionMade ) {
			sceCtrlReadBufferPositive(&pad, 1);
			if( pad.Buttons != oldButtons ) {
				if( pad.Buttons & PSP_CTRL_UP ) {
					if( selection == 1 ) {
						selection = 3;
					} else {
						selection--;
					}
					
				} else if( pad.Buttons & PSP_CTRL_DOWN ) {
					if( selection == 3 ) {
						selection = 1;
					} else {
						selection++;
					}
				} else if( pad.Buttons & PSP_CTRL_CROSS ) {
					if( selection==3 ) {
						exitYet = FALSE;
						selection = 2;
						oldButtons = pad.Buttons;
						drawBorder(FALSE);
						printHexC(nColor1, 1, 66, 3, "Are you sure you want to exit Bomb Brusher?");
						while( !exitYet ) {
							if( selection==1 ) {
								printHexCBox(nColor1, nColor1, 1, 66, 10, "Yes");
								printHexCBox(0x000000, nColor1, 1, 66, 13, "No");
							} else {
								printHexCBox(0x000000, nColor1, 1, 66, 10, "Yes");
								printHexCBox(nColor1, nColor1, 1, 66, 13, "No");
							}
							sceCtrlReadBufferPositive(&pad, 1);
							if( pad.Buttons != oldButtons ) {
								if( pad.Buttons & PSP_CTRL_UP ) {
									if( selection == 1 ) {
										selection = 2;
									} else {
										selection = 1;
									}
								} else if( pad.Buttons & PSP_CTRL_DOWN ) {
									if( selection == 1 ) {
										selection = 2;
									} else {
										selection = 1;
									}
								} else if( pad.Buttons & PSP_CTRL_CROSS ) {
									if( selection == 1 ) {
										sceKernelExitGame();
									} else {
										selection = 3;
										drawBorder(FALSE);
										exitYet = TRUE;
									}
								}
							}
							oldButtons = pad.Buttons;
						}
					} else if( selection == 2) {
						exitYet = FALSE;
						oldButtons = pad.Buttons;
						drawBorder(FALSE);
						printHexC(nColor1, 1, 66, 3, "Set the difficulty");
						while( !exitYet ) {
							if( difficulty==1 ) {
								sprintf(myMessage, "%c  EASY  %c", 208, 207);
								printHexC(nColor1, 1, 66, 10, myMessage);
							} else if( difficulty==2 ) {
								sprintf(myMessage, "%c MEDIUM %c", 208, 207);
								printHexC(nColor1, 1, 66, 10, myMessage);
							} else if( difficulty==3 ) {
								sprintf(myMessage, "%c  HARD  %c", 208, 207);
								printHexC(nColor1, 1, 66, 10, myMessage);
							} else if( difficulty==4 ) {
								sprintf(myMessage, "%c EXPERT %c", 208, 207);
								printHexC(nColor1, 1, 66, 10, myMessage);
							}
							sceCtrlReadBufferPositive(&pad, 1);
							if( pad.Buttons != oldButtons ) {
								if( pad.Buttons & PSP_CTRL_LEFT ) {
									if( difficulty==1 ) {
										difficulty = 4;
									} else {
										difficulty--;
									}
								}
								if( pad.Buttons & PSP_CTRL_RIGHT ) {
									if( difficulty==4 ) {
										difficulty = 1;
									} else {
										difficulty++;
									}
								}
								if( pad.Buttons & PSP_CTRL_CROSS ) {
									drawBorder(FALSE);
									exitYet = TRUE;
								}
							}
							oldButtons = pad.Buttons;
						}
					} else if( selection == 1) {
						while( !finishedGame ) {
							setupGame();
						}
						selectionMade = TRUE;
						finishedGame = FALSE;
					}
				}
			}
			printHexC(nColor1, 1, 66, 3, "Welcome to Bomb Brusher!");
			if( selection == 1) {
				printHexCBox(nColor1, nColor1, 1, 66, 10, "Play");
				printHexCBox(0x00000000, nColor1, 1, 66, 13, "Difficulty");
				printHexCBox(0x00000000, nColor1, 1, 66, 16, "Exit");
			} else if( selection == 2) {
				printHexCBox(0x00000000, nColor1, 1, 66, 10, "Play");
				printHexCBox(nColor1, nColor1, 1, 66, 13, "Difficulty");
				printHexCBox(0x00000000, nColor1, 1, 66, 16, "Exit");
			} else if( selection == 3) {
				printHexCBox(0x00000000, nColor1, 1, 66, 10, "Play");
				printHexCBox(0x00000000, nColor1, 1, 66, 13, "Difficulty");
				printHexCBox(nColor1, nColor1, 1, 66, 16, "Exit");
			}
			oldButtons = pad.Buttons;
		}
	}
	
	//sceKernelSleepThread();
	sceKernelExitGame();
	return 0;
}


